import { Vec2 } from "cc";
import { JNGSyncProtoBase } from "../../App";
import GBaseMode from "../GBaseMode";
import { v2 } from "cc";


export default class GObject<T> extends JNGSyncProtoBase<T>{

    //当前模式
    _mode:GBaseMode;

    get mode():GBaseMode{
        return this._mode;
    }
    set mode(value:GBaseMode){
        this._mode = value;
    }

    //设置镜像
    static SetMirror(role:GObject<{}>,flipX:boolean = true,flipY:boolean = false){
        let node = role.node;
        node.setScale(flipX ? -Math.abs(node.scale.x) : Math.abs(node.scale.x),flipY ? -Math.abs(node.scale.y) : Math.abs(node.scale.y))
    }

    //获取v2世界坐标
    get v2World():Vec2{
        let world = this.node.worldPosition;
        return v2(world.x,world.y);
    }

}

